

   MEMBER('test.clw')                                      ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE
   INCLUDE('BRWEXT.INC'),ONCE

                     MAP
                       INCLUDE('TEST002.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('TEST001.INC'),ONCE        !Req'd for module callout resolution
                     END


GetQueueRecord PROCEDURE                                   ! Generated from procedure template - Browse

BRW1::View:Browse    VIEW(Vault)
                       PROJECT(VAU:SID)
                       PROJECT(VAU:APPid)
                       PROJECT(VAU:OutDate)
                       PROJECT(VAU:InDate)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
VAU:SID                LIKE(VAU:SID)                  !List box control field - type derived from field
VAU:APPid              LIKE(VAU:APPid)                !List box control field - type derived from field
VAU:OutDate            LIKE(VAU:OutDate)              !List box control field - type derived from field
VAU:InDate             LIKE(VAU:InDate)               !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BrowseWindow         WINDOW('Browse Records'),AT(0,0,247,140),FONT('Microsoft Sans Serif',10,,,CHARSET:DEFAULT), |
  GRAY,MDI,SYSTEM
                       LIST,AT(5,5,235,100),USE(?List),HVSCROLL,FORMAT('60L(2)|M~SID~L(1)@n-14@60L(2)|M~APP id' & |
  '~L(1)@n-14@40L(2)|M~Out Date~L(1)@d1b@40L(2)|M~In Date~L(1)@d1b@'),FROM(Queue:Browse),IMM, |
  MSG('Browsing Records')
                       BUTTON('&Insert'),AT(5,110,40,12),USE(?Insert)
                       BUTTON('&Change'),AT(50,110,40,12),USE(?Change),DEFAULT
                       BUTTON('&Delete'),AT(95,110,40,12),USE(?Delete)
                       BUTTON('&Select'),AT(145,110,40,12),USE(?Select)
                       BUTTON('Close'),AT(200,110,40,12),USE(?Close)
                       STRING('Get(Queue:Browse,Choice(?List))'),AT(5,126),USE(?STRING1)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator

  CODE
? DEBUGHOOK(Vault:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('GetQueueRecord')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?List
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.AddItem(Toolbar)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:Vault.Open                                        ! File Vault used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?List,Queue:Browse.ViewPosition,BRW1::View:Browse,Queue:Browse,Relate:Vault,SELF) ! Initialize the browse manager
  SELF.Open(BrowseWindow)                                  ! Open window
  ?List{Prop:LineHeight} = 0
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse
  BRW1.AddSortOrder(,VAU:VaultID)                          ! Add the sort order for VAU:VaultID for sort order 1
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort0:Locator.Init(,VAU:SID,1,BRW1)                ! Initialize the browse locator using  using key: VAU:VaultID , VAU:SID
  BRW1.AddField(VAU:SID,BRW1.Q.VAU:SID)                    ! Field VAU:SID is a hot field or requires assignment from browse
  BRW1.AddField(VAU:APPid,BRW1.Q.VAU:APPid)                ! Field VAU:APPid is a hot field or requires assignment from browse
  BRW1.AddField(VAU:OutDate,BRW1.Q.VAU:OutDate)            ! Field VAU:OutDate is a hot field or requires assignment from browse
  BRW1.AddField(VAU:InDate,BRW1.Q.VAU:InDate)              ! Field VAU:InDate is a hot field or requires assignment from browse
  INIMgr.Fetch('GetQueueRecord',BrowseWindow)              ! Restore window settings from non-volatile store
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Vault.Close
  END
  IF SELF.Opened
    INIMgr.Update('GetQueueRecord',BrowseWindow)           ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateVault
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  CASE FIELD()
  OF ?List
    CASE EVENT()
    OF EVENT:AlertKey
      Get(Queue:Browse,Choice(?List))
      stop('The selected appID is ' & VAU:APPid & ' out date is ' & Format(VAU:OutDate,@d17))
      Return Level:Notify
      Select(?List)
    END
  END
  ReturnValue = PARENT.TakeFieldEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete
  END

SortHeader PROCEDURE                                       ! Generated from procedure template - Browse

Joe                  LONG                                  !
OrigSize             LONG                                  !
BRW1::View:Browse    VIEW(Vault)
                       PROJECT(VAU:SID)
                       PROJECT(VAU:APPid)
                       PROJECT(VAU:OutDate)
                       PROJECT(VAU:InDate)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
VAU:SID                LIKE(VAU:SID)                  !List box control field - type derived from field
VAU:APPid              LIKE(VAU:APPid)                !List box control field - type derived from field
VAU:OutDate            LIKE(VAU:OutDate)              !List box control field - type derived from field
VAU:InDate             LIKE(VAU:InDate)               !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BrowseWindow         WINDOW('Browse Records'),AT(0,0,247,140),FONT('Microsoft Sans Serif',10,,,CHARSET:DEFAULT), |
  GRAY,MDI,SYSTEM
                       LIST,AT(5,5,235,100),USE(?List),HVSCROLL,ALRT(MouseLeft),ALRT(MouseRight),FORMAT('60L(2)|M~S' & |
  'ID~L(1)@n-14@60L(2)|M~APP id~L(1)@n-14@40L(2)|M~Out Date~L(1)@d1b@40L(2)|M~In Date~L(1)@d1b@'), |
  FROM(Queue:Browse),IMM,MSG('Browsing Records')
                       BUTTON('&Insert'),AT(5,110,40,12),USE(?Insert)
                       BUTTON('&Change'),AT(50,110,40,12),USE(?Change),DEFAULT
                       BUTTON('&Delete'),AT(95,110,40,12),USE(?Delete)
                       BUTTON('&Select'),AT(145,110,40,12),USE(?Select)
                       BUTTON('Close'),AT(200,110,40,12),USE(?Close)
                       STRING('Tests MouseLeft'),AT(5,126),USE(?STRING1)
                     END

BRW1::LastSortOrder       BYTE
BRW1::SortHeader  CLASS(SortHeaderClassType) !Declare SortHeader Class
QueueResorted          PROCEDURE(STRING pString),VIRTUAL
                  END
ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
SetAlerts              PROCEDURE(),DERIVED
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
SetSort                PROCEDURE(BYTE NewOrder,BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator

  CODE
? DEBUGHOOK(Vault:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SortHeader')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?List
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.AddItem(Toolbar)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:Vault.Open                                        ! File Vault used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?List,Queue:Browse.ViewPosition,BRW1::View:Browse,Queue:Browse,Relate:Vault,SELF) ! Initialize the browse manager
  SELF.Open(BrowseWindow)                                  ! Open window
  ?List{Prop:LineHeight} = 0
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse
  BRW1.AddSortOrder(,VAU:VaultID)                          ! Add the sort order for VAU:VaultID for sort order 1
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort0:Locator.Init(,VAU:SID,1,BRW1)                ! Initialize the browse locator using  using key: VAU:VaultID , VAU:SID
  BRW1.AddField(VAU:SID,BRW1.Q.VAU:SID)                    ! Field VAU:SID is a hot field or requires assignment from browse
  BRW1.AddField(VAU:APPid,BRW1.Q.VAU:APPid)                ! Field VAU:APPid is a hot field or requires assignment from browse
  BRW1.AddField(VAU:OutDate,BRW1.Q.VAU:OutDate)            ! Field VAU:OutDate is a hot field or requires assignment from browse
  BRW1.AddField(VAU:InDate,BRW1.Q.VAU:InDate)              ! Field VAU:InDate is a hot field or requires assignment from browse
  INIMgr.Fetch('SortHeader',BrowseWindow)                  ! Restore window settings from non-volatile store
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  SELF.SetAlerts()
  !Initialize the Sort Header using the Browse Queue and Browse Control
  BRW1::SortHeader.Init(Queue:Browse,?List,'','',BRW1::View:Browse)
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Vault.Close
  !Kill the Sort Header
  BRW1::SortHeader.Kill()
  END
  IF SELF.Opened
    INIMgr.Update('SortHeader',BrowseWindow)               ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateVault
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.SetAlerts PROCEDURE

  CODE
  PARENT.SetAlerts
  !Initialize the Sort Header using the Browse Queue and Browse Control
  BRW1::SortHeader.SetAlerts()


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  Case KeyCode()          ! seems to work here
  Of MouseLeft orof 0001H
    If ?List{PROPLIST:MouseDownZone} = 2   ! Both zone and Row work here
    !If ?List{PROPLIST:MouseDownRow} = 0
      CASE ?List{PropList:MouseDownField}
      Of 1
        ?String1{Prop:Text} = 'Sorted by ID'
      Of 2
        ?STRING1{Prop:Text} = 'Sorted by App'
      Of 3
        ?String1{Prop:Text} = 'Sorted by Out Date'
      Of 4
        ?String1{Prop:Text} = 'Sorted by In Date'
      End
    END
  End  
  !Take Sort Headers Events
  IF BRW1::SortHeader.TakeEvents()
     RETURN Level:Notify
  END
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  CASE FIELD()
  OF ?List
    CASE EVENT()
    OF EVENT:AlertKey
      stop('alertkey ' & keycode())
      ! responds if I alert MouseRight
      ! but not if I alert MouseLeft
      
       ! STOP('column ' & ?List{PROP:Column} & ' mouse down ' & ?List{PropList:MouseDownField} & |
       !  ' mouse up ' & ?List{PropList:MouseUpField} & ' Zone ' & ?List{PROPLIST:MouseDownZone})
      !If KeyCode() = MouseLeft
      Case KeyCode()
      Of MouseLeft orof 0001H
      stop('mouse down zone is ' & ?List{PROPLIST:MouseDownZone})
      End
        !If ?List{PROPLIST:MouseDownZone} = 2   
        If ?List{PROPLIST:MouseDownRow} = 0
          CASE ?List{PropList:MouseDownField}
          Of 1
            ?String1{Prop:Text} = 'Sorted by ID'
          Of 2
            ?STRING1{Prop:Text} = 'Sorted by App'
          Of 3
            ?String1{Prop:Text} = 'Sorted by Out Date'
          Of 4
            ?String1{Prop:Text} = 'Sorted by In Date'
          End
          stop('down on header')
        END
      !End
    OF EVENT:PreAlertKey
      stop('pre alert')
      Case KeyCode()
      Of MouseLeft orof 0001H
      stop('pre ' & ?List{PROPLIST:MouseDownZone})
      End
    END
  END
  ReturnValue = PARENT.TakeFieldEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete
  END


BRW1.SetSort PROCEDURE(BYTE NewOrder,BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.SetSort(NewOrder,Force)
  IF BRW1::LastSortOrder<>NewOrder THEN
     BRW1::SortHeader.ClearSort()
  END
  BRW1::LastSortOrder=NewOrder
  RETURN ReturnValue

BRW1::SortHeader.QueueResorted       PROCEDURE(STRING pString)
  CODE
    IF pString = ''
       BRW1.RestoreSort()
       BRW1.ResetSort(True)
    ELSE
       BRW1.ReplaceSort(pString,BRW1::Sort0:Locator)
       BRW1.SetLocatorFromSort()
    END
